/*
 * _____________________________________________________________________________
 * 
 * INAF - OATS National Institute for Astrophysics - Astronomical Observatory of
 * Trieste INAF - IA2 Italian Center for Astronomical Archives
 * _____________________________________________________________________________
 * 
 * Copyright (C) 2017 Istituto Nazionale di Astrofisica
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License Version 3 as published by the
 * Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
package it.inaf.ia2.tsm.webapp.env;

import java.io.IOException;
import javax.faces.component.FacesComponent;
import javax.faces.component.UIComponentBase;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

/**
 *
 * @author Sonia Zorba {@literal <zorba at oats.inaf.it>}
 */
@FacesComponent(tagName = "modal", namespace = "http://ia2.inaf.it/component", createTag = true)
public class UIModal extends UIComponentBase {

    public static abstract class StatusObserver {

        public abstract void statusChanged(boolean isOpen);
    }

    @Override
    public void decode(FacesContext context) {

        if (getAttributes().containsKey("status-observer")) {
            StatusObserver status = (StatusObserver) getAttributes().get("status-observer");
            boolean open = Boolean.parseBoolean((String) getAttributes().get("open"));
            status.statusChanged(open);
        }
    }

    @Override
    public String getFamily() {
        return "modal";
    }

    @Override
    public void encodeBegin(FacesContext context) throws IOException {
        ResponseWriter writer = context.getResponseWriter();
        writer.write("<div class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" id=\"");
        writer.write(getClientId());
        writer.write("\">");
    }

    @Override
    public void encodeEnd(FacesContext context) throws IOException {
        ResponseWriter writer = context.getResponseWriter();
        writer.write("</div>");
    }
}
